#! /usr/bin/env python
# -*- coding: utf8 -*-
#
# Markus Reinert, 28.10.2012
#
# Pong-Spiel
# Klasse Ball

class Ball:
	def __init__(self, velocity = (0.5, 0.25), size = (20, 20), walls = [0, 1, 2, 3], bats = []):
		self.velocity = velocity		# (DELTA_X, DELTA_Y)
		self.width, self.height = size
		self.pos = self.width/2, self.height/2
		self.walls = walls
		self.bats = bats
		self.tested = False
	def fly(self):
		posNew = (self.pos[0]-self.velocity[0], self.pos[1]-self.velocity[1])
		self.tested = True
		# testen ob außerhalb
		if self.tested:
			if posNew[0] < 0 or posNew[0] > self.width or posNew[1] < 0 or posNew[1] > self.height:
				return False, posNew
		# testen ob an Wand oder Schläger
		if not (1 < posNew[1] < self.height-1):		# Wand oben unten
			for i in [0, 2]:
				if (i in self.walls) or testBats(self.bats, i, posNew[0]):
					self.velocity = (self.velocity[0], -self.velocity[1])
					self.tested = True
					break
		if not (1 < posNew[0] < self.width-1):		# Wand rechts links
			for i in [1, 3]:
				if (i in self.walls) or testBats(self.bats, i, posNew[1]):
					self.velocity = (-self.velocity[0], self.velocity[1])
					self.tested = True
					break
		self.pos = (self.pos[0]-self.velocity[0], self.pos[1]-self.velocity[1])
		return True, 0

def testBats(bats, line, pos):
	for bat in bats:
		if bat.line == line:
			if bat.pos < pos < bat.pos+bat.sizeBat:
				return True
	return False

